package org.springframework.samples.petclinic.hibernate;

import org.hibernate.HibernateException;
import org.hibernate.event.SaveOrUpdateEvent;
import org.hibernate.event.SaveOrUpdateEventListener;
import org.springframework.samples.petclinic.ModifiedObjectTracker;

@SuppressWarnings("serial")
public class SaveOrUpdateHandler implements SaveOrUpdateEventListener {
	private ModifiedObjectTracker tracker;

	public void onSaveOrUpdate(SaveOrUpdateEvent event) throws HibernateException {
		getModifiedObjectTracker().notifyModified(event.getEntityName());
	}
	
	public ModifiedObjectTracker getModifiedObjectTracker() {
		return tracker;
	}

	public void setModifiedObjectTracker(ModifiedObjectTracker tracker) {
		this.tracker = tracker;
	}
}
